<?php
/**
 * @version		1.0
 * @package		Test Content K2 Plugin (K2 plugin)
 * @author    	Andrea Forghieri 
 * @copyright	
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die ('Restricted access');


// Load the K2 Plugin API
JLoader::register('K2Plugin', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

class plgK2Custom_Properties extends K2Plugin {

	// Some params
	var $pluginName = 'custom_properties';
	var $pluginNameHumanReadable = 'Custom Properties for K2 items';

	function plgK2Custom_Properties( & $subject, $params) {
		parent::__construct($subject, $params);
	}

	function onK2PrepareContent( &$item, &$params, $limitstart) {
		
		if(empty($item)) return;
		if($item == 'TableK2Category') return;
				
		$mainframe = &JFactory::getApplication();
		$plugin = &JPluginHelper::getPlugin('k2', $this->pluginName);
		$pluginParams = new JParameter($plugin->params);

		if(isset($item->id) && $CPtags = $this->getCpTags($item->id)){
			foreach($CPtags as $CpTag){
				$tagName = $CpTag->fname;
				if(!isset($item->cptags->$tagName)){
					$item->cptags->$tagName = array($CpTag);
				}
				else{
					array_push($item->cptags->$tagName, $CpTag);
				}
			}
		}

	}
	function onRenderAdminForm( &$item, $type, $tab = '') {
		return ;
	}	
	
	/**
	 * 
	 * returns all Cp tags (and associated articles if any) as objects
	 * @param unknown_type $k2_id
	 * @return array of objects or false
	 */
	private function getCpTags($k2_id){
			
		if(empty($k2_id)) return false;
		
		$database 		= JFactory::getDBO();
		$user 			= JFactory::getUser();
		$groups 		= $user->getAuthorisedViewLevels();
		$acl_groups 	= implode(',', $groups);	

		$query = "SELECT DISTINCT f.id as fid, f.name AS fname, f.label AS flabel, 
			v.id AS vid, v.name AS vname, v.label AS vlabel, REPLACE(v.label, ' ', '-') AS url_label, 
			c.id AS cid, c.title AS article_title, c.introtext AS article_intro, c.`fulltext` AS article_fulltext 
			FROM #__custom_properties AS cp
				INNER JOIN #__custom_properties_fields AS f
				ON (cp.field_id = f.id )
				INNER JOIN #__custom_properties_values AS v
				ON (cp.value_id = v.id )
				LEFT JOIN #__content AS c
				ON (v.article_id = c.id)
			WHERE cp.ref_table = 'k2_items'
				AND cp.content_id = '$k2_id'
				AND f.published = '1'
				AND f.access IN($acl_groups)
			ORDER BY f.ordering, cp.id ";
	
		$database->setQuery($query);
		$database->getErrorMsg();
		$tags = $database->loadObjectList();		
		
		return $tags;
	}

} // END CLASS


